/********************************************************************************/
/* Name		: AddWhitwList.java														*/
/* Copyright	: 2003 SATCOMLABS LTD.				     						*/
/* Team		: Spam Control Team													*/
/* Developer	: Pavan Gupta													*/
/* Last Updated	: M 29/12/2003											*/
/* Abstract	: Java Bean for Add new addresses to ASL							*/
/* Called from	: interaddwhitelist.jsp 											*/
/* Calls	: 																	*/
/********************************************************************************/
package com.antispam;

import java.text.SimpleDateFormat;
import java.util.Date;
import com.DBConnection;

public class AddWhiteList
{
	DBConnection dbconn = new DBConnection ();

	public int aslid = 0;
	public int userid = 0;
	public int domainid = 0;
	public String mailerid = "";
	public String mailerdomain = "";
	
	public int conditionid = 0;
	public int approvalid = 0;
	public String cr_date = ""; //CHALLENGE RESPONSE DATE
	public String keymail = "";
	public String expirationdate = "";

	public String flag = "";

	/* SET-GET THE ASL ID */
	public void setAslid ( int newaslid )
	{
		aslid = newaslid;
	}
	public int getAslid ( )
	{
		return aslid;
	}

	/* SET-GET THE USER ID */
	public void setUserid ( int newuserid )
	{
		userid = newuserid;
	}
	public int getUserid ( )
	{
		return userid;
	}

	/* SET-GET THE DOMAIN ID */
	public void setDomainid ( int newdomainid )
	{
		domainid = newdomainid;
	}
	public int getDomainid ( )
	{
		return domainid;
	}

	/* SET-GET THE MAILER ID */
	public void setMailerid ( String newmailerid )
	{	  
		mailerid = newmailerid;
	}
	public String getMailerid ( )
	{
		return mailerid;      
	}
	/* SET-GET THE MAILER DOMAIN */
	public void setMailerdomain ( String newmailerdomain )
	{	  
		mailerdomain = newmailerdomain;
	}
	public String getMailerdomain ( )
	{
		return mailerdomain;      
	}

	/* SET THE DATE OF ENTRY */
	//Date entrydate = new Date();
	//SimpleDateFormat sdf = new SimpleDateFormat("MM/dd/yyyy hh:mm:ss");
	//String dateofentry = sdf.format(entrydate);
	//Date dateofentry = new Date();


	/* SET-GET THE CONDITION ID */
	public void setConditionid ( int newconditionid )
	{	  
		conditionid = newconditionid;
	}
	public int getConditionid ( )
	{
		return conditionid;      
	}

	/* SET-GET THE APPROVAL ID */
	public void setApprovalid ( int newapprovalid )
	{	  
		approvalid = newapprovalid;
	}
	public int getApprovalid ( )
	{
		return approvalid;      
	}

	/* SET-GET THE CHALLENGE RESPONSE DATE */
	public void setCr_date ( String newcr_date )
	{	  
		cr_date = newcr_date;      
	}
	public String getCr_date( )
	{
		return cr_date;
	}

	/* SET-GET THE KEYMAIL */
	public void setKeymail ( String newkeymail )
	{	  
		keymail = newkeymail;      
	}
	public String getKeymail ( )
	{
		return keymail;
	}

	/* SET-GET THE EXPIRATION DATE */
	public void setExpirationdate ( String newexpirationdate )
	{	  
		expirationdate = newexpirationdate;
	}
	public String getExpirationdate ( )
	{
		return expirationdate;      
	}
	
	public void setFlag( String s )
	{
		flag = s;
	}
	public String getFlag()
	{
		return flag;
	}


	public String registered ( ) 
	{
		String retVal = "";
		java.sql.Connection conn = null;
		java.sql.Statement smt = null;
		java.sql.Statement smt_valid = null;
		java.sql.ResultSet rs = null;
		java.sql.ResultSet rs1 = null;
		java.sql.ResultSet rs_valid = null;
		String qry = null;
		try
		{
			conn = dbconn.getConnection();
			smt = conn.createStatement();

			if ( flag.equals("UPDATEPOLICY") )
			{
				qry = "UPDATE ASL SET CONDITIONID="+conditionid+" WHERE ASLID = "+aslid;
				smt.executeUpdate ( qry );
			}

			else if ( flag.equals("UPDATESCOPE") )
			{
				qry = "UPDATE ASL SET APPROVALID = "+approvalid+" WHERE ASLID = "+aslid;
				smt.executeUpdate ( qry );
			}

			else if ( flag.equals("UPDATE") )
			{
				qry = "UPDATE ASL SET CONDITIONID="+conditionid+", APPROVALID = "+approvalid+" WHERE ASLID = "+aslid;
				smt.executeUpdate ( qry );
				retVal= "Update Operation Succeeded";
			}

			else if ( flag.equals("ADD") )
			{
				qry = "SELECT ASLID FROM ASL WHERE MAILERID='"+mailerid+"' AND MAILERDOMAIN='"+mailerdomain+"' AND USERID="+userid;
				rs = smt.executeQuery ( qry );
				if ( rs.next() )
					retVal = mailerid+"@"+mailerdomain+" already exists";
				else
				{
					smt_valid = conn.createStatement();
					rs_valid = smt_valid.executeQuery("select mailerid from asl where mailerdomain='"+mailerdomain+"' and (approvalid = 2 or approvalid = 3) and conditionid = 1 AND USERID="+userid);

					if(rs_valid.next() && (conditionid == 2 || conditionid == 3))
					{
						retVal ="Can't add "+mailerid+"@"+mailerdomain+", This domain is Pre-approved";
					}
					else
					{
					
					qry = "INSERT INTO ASL(USERID,MAILERID,MAILERDOMAIN,DATE_OF_ENTRY,CONDITIONID,APPROVALID) VALUES("+userid+", '"+mailerid.toLowerCase()+"', '"+mailerdomain.toLowerCase()+"', now(), "+conditionid+", "+approvalid+")";
					smt.executeUpdate( qry );
					retVal =mailerid+"@"+mailerdomain+" added to ASL";
					}
				}
			}
			else if ( flag.equals("DELETE") )
			{
				qry = "DELETE FROM ASL WHERE ASLID="+aslid;
				smt.executeUpdate( qry );
				retVal= "Delete Operation Succeeded";
			}
			else if(flag.equals("COPY"))
			{
				String mailer_id = "";
				String mailer_domain = "";
				int condition_id = 0;
				int approval_id = 0;
				qry = "SELECT MAILERID,MAILERDOMAIN,CONDITIONID,APPROVALID FROM ASL WHERE ASLID="+aslid;
				rs = smt.executeQuery(qry);
				if(rs.next())
				{
					mailer_id = rs.getString( 1 );
					mailer_domain = rs.getString( 2 );
					condition_id = rs.getInt( 3 );
					approval_id = rs.getInt( 4 );
				}
				qry = "SELECT * FROM DOMAINSASL WHERE MAILERID='"+mailer_id+"' AND MAILERDOMAIN='"+mailer_domain+"'";
				rs1 = smt.executeQuery(qry);
				if(rs1.next())
				{}
				else
				{

					//qry = "INSERT INTO DOMAINSASL (DOMAINID,MAILERID,MAILERDOMAIN,DATE_INSERSION,CONDITIONID,APPROVALID) VALUES ("+domainid+",'"+mailer_id+"','"+mailer_domain+"','"+dateofentry+"',"+condition_id+","+approval_id+")";
					qry = "INSERT INTO DOMAINSASL (DOMAINID,MAILERID,MAILERDOMAIN,DATE_INSERSION,CONDITIONID,APPROVALID) VALUES ("+domainid+",'"+mailer_id+"','"+mailer_domain+"',now(),"+condition_id+","+approval_id+")";
					smt.executeUpdate(qry);
				}
				retVal = "Successfully Copied to Domains ASL";
			}
		}
		catch ( java.sql.SQLException sqle )
		{
			System.out.println("SQLE Exception-->"+sqle);
			retVal=sqle.toString();
		}
		catch ( Exception e )
		{
			System.out.println("Exception-->"+e);
			retVal=e.toString();
		}
		finally
		{
			try 
			{
				smt.close();
				smt_valid.close();
				conn.close();
			}
			catch ( Exception ignored ) {}
		}
		return retVal;
	}
}
